/* ukliens.c - Egyszeru pelda kliens a Unix domain socket 
   hasznalatara. */

#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <unistd.h>

#define SOCKET_PATH "/tmp/stonith.socket"

int main(void)
{
  struct sockaddr_un address;
  int sock;
  size_t addrLength;
  char buf[1024];
  int amount;

  /* Letrehozzuk a socket-et. */
  if((sock = socket(PF_UNIX, SOCK_STREAM, 0)) < 0)
  {
    perror("socket");
    exit(1);
  }

  address.sun_family = AF_UNIX;
  strcpy(address.sun_path, SOCKET_PATH);

  /* A teljes cim hossz tartalmazza a sun_family elemet es az 
     eleresi ut hosszat. */
  addrLength = sizeof(address.sun_family) + 
               strlen(address.sun_path);

  /* Kapcsolodunk a szerverhez. */
  if(connect(sock, (struct sockaddr *) &address, addrLength))
  {
    perror("connect");
    exit(1);
  }

  /* Elkuldjuk az adatokat. */
  while((amount = read(STDIN_FILENO, buf, sizeof(buf))) > 0) 
  {
    if (write(sock, buf, amount) != amount) 
    {
      perror("write");
      exit(1);
    }
    amount = read(sock, buf, sizeof(buf));
    write(1, buf, amount);
  }
  if(amount < 0)
  {
    perror("read");
    exit(1);
  }

  /* Bontjuk a kapcsolatot. */
  close(sock);
  return 0;
}
